<script setup lang="ts">
import ErrorDisplay from '@/components/ErrorDisplay.vue'
import router from '@/router'
import { useAuthStore } from '@/stores/auth'
import { ref, type Ref } from 'vue'

const props = defineProps<{ type: 'login' | 'register' }>()

const authStore = useAuthStore()

const login = ref('')
const password = ref('')

const loading = ref(false)
const loginError: Ref<Error | null> = ref(null)

const submitForm = async () => {
  try {
    // Active l'indicateur de chargement
    loading.value = true
    loginError.value = null

    if (props.type === 'login') {
      await authStore.login(login.value, password.value)
    } else if (props.type === 'register') {
      await authStore.register(login.value, password.value)
    } else {
      throw 'Non implémenté'
    }

    // Réinitialiser les champs du formulaire
    login.value = ''
    password.value = ''

    router.push('/playlists')
  } catch (error) {
    if (!(error instanceof Error)) {
      console.error(error)
    } else {
      loginError.value = error
    }
  }

  loading.value = false
}
</script>

<template>
  <div class="min-h-full min-w-full flex justify-center items-stretch flex-grow">
    <div class="max-w-md w-full flex flex-col justify-center">
      <div>
        <h2 class="mt-6 text-center text-3xl leading-9 font-extrabold text-gray-900">
          <span v-if="props.type === 'login'">Connexion</span>
          <span v-else-if="props.type === 'register'">Inscription</span>
          <span v-else>SITUATION INCONNUE</span>
        </h2>
      </div>
      <form class="mt-8 mr-2 ml-2 sm:mr-0 sm:ml-0" @submit.prevent="submitForm">
        <div class="rounded-md flex flex-col gap-2">
          <div>
            <input
              v-model="login"
              aria-label="Login"
              name="login"
              type="text"
              required
              class="relative w-full input input-bordered"
              placeholder="Login"
            />
          </div>
          <div>
            <input
              v-model="password"
              aria-label="Password"
              name="password"
              type="password"
              required
              class="relative w-full input input-bordered"
              placeholder="Mot de passe"
            />
          </div>
        </div>

        <ErrorDisplay :login-error="loginError" />

        <div class="mt-6">
          <button
            type="submit"
            class="group relative w-full btn btn-primary justify-center"
            :disabled="loading"
          >
            <span v-if="props.type === 'login'">Se connecter</span>
            <span v-else-if="props.type === 'register'">S'inscrire</span>
            <span v-else>SITUATION INCONNUE</span>
          </button>
        </div>
      </form>
    </div>
  </div>
</template>
